/*
 *  ======== ti_drivers_config.c ========
 *  Configured TI-Drivers module definitions
 *
 *  DO NOT EDIT - This file is generated for the CC1312R7RGZ
 *  by the SysConfig tool.
 */

#include <stddef.h>
#include <stdint.h>

#ifndef DeviceFamily_CC13X2X7
#define DeviceFamily_CC13X2X7
#endif

#include <ti/devices/DeviceFamily.h>

#include "ti_drivers_config.h"

/*
 *  ============================= Display =============================
 */

#include <ti/display/Display.h>
#include <ti/display/DisplayUart2.h>

#define CONFIG_Display_COUNT 1


#define Display_UART2BUFFERSIZE 1024
static char displayUART2Buffer[Display_UART2BUFFERSIZE];

DisplayUart2_Object displayUart2Object;

const DisplayUart2_HWAttrs displayUart2HWAttrs = {
    .uartIdx      = CONFIG_UART2_1,
    .baudRate     = 115200,
    .mutexTimeout = (unsigned int)(-1),
    .strBuf       = displayUART2Buffer,
    .strBufLen    = Display_UART2BUFFERSIZE
};

const Display_Config Display_config[CONFIG_Display_COUNT] = {
    /* CONFIG_Display_0 */
    {
        .fxnTablePtr = &DisplayUart2Min_fxnTable,
        .object      = &displayUart2Object,
        .hwAttrs     = &displayUart2HWAttrs
    },
};

const uint_least8_t Display_count = CONFIG_Display_COUNT;

/*
 *  =============================== ADC ===============================
 */

#include <ti/drivers/ADC.h>
#include <ti/drivers/adc/ADCCC26XX.h>
#include <ti/drivers/GPIO.h>

#define CONFIG_ADC_COUNT 1

/*
 *  ======== adcCC26xxObjects ========
 */
ADCCC26XX_Object adcCC26xxObjects[CONFIG_ADC_COUNT];

/*
 *  ======== adcCC26xxHWAttrs ========
 */
const ADCCC26XX_HWAttrs adcCC26xxHWAttrs[CONFIG_ADC_COUNT] = {
    /* CONFIG_ADC_VBAT */
    {
        .adcDIO              = CONFIG_GPIO_ADC_VBAT_AIN,
        .adcCompBInput       = ADC_COMPB_IN_AUXIO0,
        .refSource           = ADCCC26XX_FIXED_REFERENCE,
        .samplingDuration    = ADCCC26XX_SAMPLING_DURATION_2P7_US,
        .inputScalingEnabled = true,
        .refVoltage          = 3300000,
        .triggerSource       = ADCCC26XX_TRIGGER_MANUAL,
        .returnAdjustedVal   = false
    },
};

/*
 *  ======== ADC_config ========
 */
const ADC_Config ADC_config[CONFIG_ADC_COUNT] = {
    /* CONFIG_ADC_VBAT */
    {
        .fxnTablePtr = &ADCCC26XX_fxnTable,
        .object = &adcCC26xxObjects[CONFIG_ADC_VBAT],
        .hwAttrs = &adcCC26xxHWAttrs[CONFIG_ADC_VBAT]
    },
};

const uint_least8_t CONFIG_ADC_VBAT_CONST = CONFIG_ADC_VBAT;
const uint_least8_t ADC_count = CONFIG_ADC_COUNT;

/*
 *  =============================== DMA ===============================
 */

#include <ti/drivers/dma/UDMACC26XX.h>
#include <ti/devices/cc13x2x7_cc26x2x7/driverlib/udma.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_memmap.h>

UDMACC26XX_Object udmaCC26XXObject;

const UDMACC26XX_HWAttrs udmaCC26XXHWAttrs = {
    .baseAddr        = UDMA0_BASE,
    .powerMngrId     = PowerCC26XX_PERIPH_UDMA,
    .intNum          = INT_DMA_ERR,
    .intPriority     = (~0)
};

const UDMACC26XX_Config UDMACC26XX_config[1] = {
    {
        .object         = &udmaCC26XXObject,
        .hwAttrs        = &udmaCC26XXHWAttrs,
    },
};

/*
 *  =============================== GPIO ===============================
 */

#include <ti/drivers/GPIO.h>
#include <ti/drivers/gpio/GPIOCC26XX.h>

/* The range of pins available on this device */
const uint_least8_t GPIO_pinLowerBound = 1;
const uint_least8_t GPIO_pinUpperBound = 30;

/*
 *  ======== gpioPinConfigs ========
 *  Array of Pin configurations
 */
GPIO_PinConfig gpioPinConfigs[31] = {
    0, /* Pin is not available on this device */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_DIO1 */
    GPIO_CFG_NO_DIR, /* DIO_2 */
    GPIO_CFG_NO_DIR, /* DIO_3 */
    /* Owned by CONFIG_I2C_RTCC as SCL */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_UP_INTERNAL, /* CONFIG_GPIO_I2C_RTCC_SCL */
    /* Owned by CONFIG_I2C_RTCC as SDA */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_UP_INTERNAL, /* CONFIG_GPIO_I2C_RTCC_SDA */
    /* Owned by CONFIG_GPTIMER_1 as PWM Pin */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_PWM_GREEN */
    /* Owned by CONFIG_GPTIMER_2 as PWM Pin */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_PWM_BLUE */
    /* Owned by CONFIG_SPI_MEM as MOSI */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_SPI_MEM_MOSI */
    /* Owned by CONFIG_SPI_MEM as MISO */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_NONE_INTERNAL, /* CONFIG_GPIO_SPI_MEM_MISO */
    /* Owned by CONFIG_SPI_MEM as SCLK */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_SPI_MEM_SCLK */
    /* Owned by CONFIG_SD_0 as SD Slave Select */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_HIGH, /* CONFIG_GPIO_MEM_CS */
    /* Owned by CONFIG_BUTTON_0 as Button GPIO */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_UP_INTERNAL, /* CONFIG_GPIO_BUTTON_IN */
    /* Owned by CONFIG_LED_BUTTON as LED GPIO */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_LED_BUTTON_GPIO */
    /* Owned by CONFIG_SPI_IMU as SS */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_HIGH, /* CONFIG_GPIO_SPI_IMU_SS */
    /* Owned by CONFIG_SPI_IMU as SCLK */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_SPI_IMU_SCLK */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_DIO16 */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_DIO17 */
    /* Owned by CONFIG_SPI_IMU as MISO */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_NONE_INTERNAL, /* CONFIG_GPIO_SPI_IMU_MISO */
    /* Owned by CONFIG_SPI_IMU as MOSI */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_SPI_IMU_MOSI */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_DOWN_INTERNAL, /* CONFIG_GPIO_IMU_INT */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_NONE_INTERNAL, /* CONFIG_GPIO_CHG_STAT */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_UP_INTERNAL, /* CONFIG_GPIO_RTCC_INT */
    GPIO_CFG_NO_DIR, /* DIO_23 */
    GPIO_CFG_NO_DIR, /* DIO_24 */
    /* Owned by CONFIG_GPTIMER_0 as PWM Pin */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_PWM_RED */
    /* Owned by CONFIG_UART2_1 as TX */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_HIGH, /* CONFIG_GPIO_UART2_1_TX */
    /* Owned by CONFIG_UART2_1 as RX */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_DOWN_INTERNAL, /* CONFIG_GPIO_UART2_1_RX */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_I2C1_EN */
    GPIO_CFG_OUTPUT_INTERNAL | GPIO_CFG_OUT_STR_MED | GPIO_CFG_OUT_LOW, /* CONFIG_GPIO_BATT_M_EN */
    /* Owned by CONFIG_ADC_VBAT as ADC Pin */
    GPIO_CFG_INPUT_INTERNAL | GPIO_CFG_IN_INT_NONE | GPIO_CFG_PULL_NONE_INTERNAL, /* CONFIG_GPIO_ADC_VBAT_AIN */
};

/*
 *  ======== gpioCallbackFunctions ========
 *  Array of callback function pointers
 *  Change at runtime with GPIO_setCallback()
 */
GPIO_CallbackFxn gpioCallbackFunctions[31];

/*
 *  ======== gpioUserArgs ========
 *  Array of user argument pointers
 *  Change at runtime with GPIO_setUserArg()
 *  Get values with GPIO_getUserArg()
 */
void* gpioUserArgs[31];

const uint_least8_t CONFIG_GPIO_UART2_1_TX_CONST = CONFIG_GPIO_UART2_1_TX;
const uint_least8_t CONFIG_GPIO_UART2_1_RX_CONST = CONFIG_GPIO_UART2_1_RX;
const uint_least8_t CONFIG_GPIO_ADC_VBAT_AIN_CONST = CONFIG_GPIO_ADC_VBAT_AIN;
const uint_least8_t CONFIG_GPIO_RTCC_INT_CONST = CONFIG_GPIO_RTCC_INT;
const uint_least8_t CONFIG_GPIO_BATT_M_EN_CONST = CONFIG_GPIO_BATT_M_EN;
const uint_least8_t CONFIG_GPIO_CHG_STAT_CONST = CONFIG_GPIO_CHG_STAT;
const uint_least8_t CONFIG_GPIO_IMU_INT_CONST = CONFIG_GPIO_IMU_INT;
const uint_least8_t CONFIG_GPIO_I2C1_EN_CONST = CONFIG_GPIO_I2C1_EN;
const uint_least8_t CONFIG_GPIO_DIO1_CONST = CONFIG_GPIO_DIO1;
const uint_least8_t CONFIG_GPIO_DIO16_CONST = CONFIG_GPIO_DIO16;
const uint_least8_t CONFIG_GPIO_DIO17_CONST = CONFIG_GPIO_DIO17;
const uint_least8_t CONFIG_GPIO_I2C_RTCC_SDA_CONST = CONFIG_GPIO_I2C_RTCC_SDA;
const uint_least8_t CONFIG_GPIO_I2C_RTCC_SCL_CONST = CONFIG_GPIO_I2C_RTCC_SCL;
const uint_least8_t CONFIG_GPIO_MEM_CS_CONST = CONFIG_GPIO_MEM_CS;
const uint_least8_t CONFIG_GPIO_SPI_MEM_SCLK_CONST = CONFIG_GPIO_SPI_MEM_SCLK;
const uint_least8_t CONFIG_GPIO_SPI_MEM_MISO_CONST = CONFIG_GPIO_SPI_MEM_MISO;
const uint_least8_t CONFIG_GPIO_SPI_MEM_MOSI_CONST = CONFIG_GPIO_SPI_MEM_MOSI;
const uint_least8_t CONFIG_GPIO_SPI_IMU_SCLK_CONST = CONFIG_GPIO_SPI_IMU_SCLK;
const uint_least8_t CONFIG_GPIO_SPI_IMU_MISO_CONST = CONFIG_GPIO_SPI_IMU_MISO;
const uint_least8_t CONFIG_GPIO_SPI_IMU_MOSI_CONST = CONFIG_GPIO_SPI_IMU_MOSI;
const uint_least8_t CONFIG_GPIO_BUTTON_IN_CONST = CONFIG_GPIO_BUTTON_IN;
const uint_least8_t CONFIG_GPIO_SPI_IMU_SS_CONST = CONFIG_GPIO_SPI_IMU_SS;
const uint_least8_t CONFIG_LED_BUTTON_GPIO_CONST = CONFIG_LED_BUTTON_GPIO;
const uint_least8_t CONFIG_GPIO_PWM_RED_CONST = CONFIG_GPIO_PWM_RED;
const uint_least8_t CONFIG_GPIO_PWM_GREEN_CONST = CONFIG_GPIO_PWM_GREEN;
const uint_least8_t CONFIG_GPIO_PWM_BLUE_CONST = CONFIG_GPIO_PWM_BLUE;

/*
 *  ======== GPIO_config ========
 */
const GPIO_Config GPIO_config = {
    .configs = (GPIO_PinConfig *)gpioPinConfigs,
    .callbacks = (GPIO_CallbackFxn *)gpioCallbackFunctions,
    .userArgs = gpioUserArgs,
    .intPriority = (~0)
};

/*
 *  =============================== I2C ===============================
 */

#include <ti/drivers/I2C.h>
#include <ti/drivers/i2c/I2CCC26XX.h>
#include <ti/drivers/power/PowerCC26XX.h>

#include <ti/devices/DeviceFamily.h>
#include DeviceFamily_constructPath(inc/hw_ints.h)
#include DeviceFamily_constructPath(inc/hw_memmap.h)
#include DeviceFamily_constructPath(driverlib/ioc.h)

#define CONFIG_I2C_COUNT 1

/*
 *  ======== i2cCC26xxObjects ========
 */
I2CCC26XX_Object i2cCC26xxObjects[CONFIG_I2C_COUNT];

/*
 *  ======== i2cCC26xxHWAttrs ========
 */
const I2CCC26XX_HWAttrsV1 i2cCC26xxHWAttrs[CONFIG_I2C_COUNT] = {
    /* CONFIG_I2C_RTCC */
    {
        .baseAddr    = I2C0_BASE,
        .powerMngrId = PowerCC26XX_PERIPH_I2C0,
        .intNum      = INT_I2C_IRQ,
        .intPriority = (~0),
        .swiPriority = 0,
        .sclPin      = CONFIG_GPIO_I2C_RTCC_SCL,
        .sclPinMux   = IOC_PORT_MCU_I2C_MSSCL,
        .sdaPin      = CONFIG_GPIO_I2C_RTCC_SDA,
        .sdaPinMux   = IOC_PORT_MCU_I2C_MSSDA
    },
};

/*
 *  ======== I2C_config ========
 */
const I2C_Config I2C_config[CONFIG_I2C_COUNT] = {
    /* CONFIG_I2C_RTCC */
    {
        .object      = &i2cCC26xxObjects[CONFIG_I2C_RTCC],
        .hwAttrs     = &i2cCC26xxHWAttrs[CONFIG_I2C_RTCC]
    },
};

const uint_least8_t CONFIG_I2C_RTCC_CONST = CONFIG_I2C_RTCC;
const uint_least8_t I2C_count = CONFIG_I2C_COUNT;

/*
 *  =============================== PWM ===============================
 */

#include <ti/drivers/PWM.h>
#include <ti/drivers/pwm/PWMTimerCC26XX.h>

/* include driverlib definitions */
#include <ti/devices/cc13x2x7_cc26x2x7/driverlib/ioc.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_ints.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_memmap.h>

#define CONFIG_PWM_COUNT 3

/*
 *  ======== pwmCC26XXObjects ========
 */
PWMTimerCC26XX_Object pwmTimerCC26XXObjects[CONFIG_PWM_COUNT];

/*
 *  ======== pwmCC26XXHWAttrs ========
 */
const PWMTimerCC26XX_HwAttrs pwmTimerCC26XXHWAttrs[CONFIG_PWM_COUNT] = {
    /* CONFIG_LED_RED_PWM */
    {
        .pwmPin = CONFIG_GPIO_PWM_RED,
        .gpTimerUnit = CONFIG_GPTIMER_0
    },
    /* CONFIG_LED_GREEN_PWM */
    {
        .pwmPin = CONFIG_GPIO_PWM_GREEN,
        .gpTimerUnit = CONFIG_GPTIMER_1
    },
    /* CONFIG_LED_BLUE_PWM */
    {
        .pwmPin = CONFIG_GPIO_PWM_BLUE,
        .gpTimerUnit = CONFIG_GPTIMER_2
    },
};

/*
 *  ======== PWM_config ========
 */
const PWM_Config PWM_config[CONFIG_PWM_COUNT] = {
    /* CONFIG_LED_RED_PWM */
    {
        .fxnTablePtr = &PWMTimerCC26XX_fxnTable,
        .object = &pwmTimerCC26XXObjects[CONFIG_LED_RED_PWM],
        .hwAttrs = &pwmTimerCC26XXHWAttrs[CONFIG_LED_RED_PWM]
    },
    /* CONFIG_LED_GREEN_PWM */
    {
        .fxnTablePtr = &PWMTimerCC26XX_fxnTable,
        .object = &pwmTimerCC26XXObjects[CONFIG_LED_GREEN_PWM],
        .hwAttrs = &pwmTimerCC26XXHWAttrs[CONFIG_LED_GREEN_PWM]
    },
    /* CONFIG_LED_BLUE_PWM */
    {
        .fxnTablePtr = &PWMTimerCC26XX_fxnTable,
        .object = &pwmTimerCC26XXObjects[CONFIG_LED_BLUE_PWM],
        .hwAttrs = &pwmTimerCC26XXHWAttrs[CONFIG_LED_BLUE_PWM]
    },
};

const uint_least8_t CONFIG_LED_RED_PWM_CONST = CONFIG_LED_RED_PWM;
const uint_least8_t CONFIG_LED_GREEN_PWM_CONST = CONFIG_LED_GREEN_PWM;
const uint_least8_t CONFIG_LED_BLUE_PWM_CONST = CONFIG_LED_BLUE_PWM;
const uint_least8_t PWM_count = CONFIG_PWM_COUNT;

/*
 *  =============================== Power ===============================
 */
#include <ti/drivers/Power.h>
#include <ti/drivers/power/PowerCC26X2.h>
#include "ti_drivers_config.h"

extern void PowerCC26XX_standbyPolicy(void);
extern bool PowerCC26XX_calibrate(unsigned int);

const PowerCC26X2_Config PowerCC26X2_config = {
    .enablePolicy             = true,
    .policyInitFxn            = NULL,
    .policyFxn                = PowerCC26XX_standbyPolicy,
    .calibrateFxn             = PowerCC26XX_calibrate,
    .calibrateRCOSC_LF        = true,
    .calibrateRCOSC_HF        = true,
    .enableTCXOFxn            = NULL
};

/*
 *  =============================== SD ===============================
 */
#include <ti/drivers/SD.h>
#include <ti/drivers/sd/SDSPI.h>
#include <ti/drivers/SDFatFS.h>

#define CONFIG_SD_COUNT 1
#define CONFIG_SD_FATFS_COUNT 1


SDFatFS_Object sdfatfsObjects[CONFIG_SD_FATFS_COUNT];

const SDFatFS_Config SDFatFS_config[CONFIG_SD_FATFS_COUNT] = {
    /* CONFIG_SD_0 */
    {
        .object = &sdfatfsObjects[CONFIG_SD_0]
    },
};

const uint_least8_t SDFatFS_count = CONFIG_SD_FATFS_COUNT;

SDSPI_Object sdspiObjects[CONFIG_SD_COUNT];

static const SDSPI_HWAttrs sdspiHWAttrs[CONFIG_SD_COUNT] = {
    /* CONFIG_SD_0 */
    {
        .spiIndex = CONFIG_SPI_MEM,
        .spiCsGpioIndex = CONFIG_GPIO_MEM_CS
    },
};

const SD_Config SD_config[CONFIG_SD_COUNT] = {
    /* CONFIG_SD_0 */
    {
        .fxnTablePtr = &SDSPI_fxnTable,
        .object = &sdspiObjects[CONFIG_SD_0],
        .hwAttrs = &sdspiHWAttrs[CONFIG_SD_0]
    },
};

const uint_least8_t CONFIG_SD_0_CONST = CONFIG_SD_0;
const uint_least8_t SD_count = CONFIG_SD_COUNT;

/*
 *  =============================== SPI DMA ===============================
 */
#include <ti/drivers/SPI.h>
#include <ti/drivers/spi/SPICC26X2DMA.h>
#include <ti/drivers/dma/UDMACC26XX.h>

#include <ti/devices/DeviceFamily.h>
#include DeviceFamily_constructPath(driverlib/ioc.h)

#define CONFIG_SPI_COUNT 2

/*
 *  ======== spiCC26X2DMAObjects ========
 */
SPICC26X2DMA_Object spiCC26X2DMAObjects[CONFIG_SPI_COUNT];

/*
 * ======== spiCC26X2DMA uDMA Table Entries  ========
 */
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi0TxControlTableEntry, UDMA_CHAN_SSI0_TX);
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi0RxControlTableEntry, UDMA_CHAN_SSI0_RX);
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi0TxAltControlTableEntry, (UDMA_CHAN_SSI0_TX | UDMA_ALT_SELECT));
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi0RxAltControlTableEntry, (UDMA_CHAN_SSI0_RX | UDMA_ALT_SELECT));

ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi1TxControlTableEntry, UDMA_CHAN_SSI1_TX);
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi1RxControlTableEntry, UDMA_CHAN_SSI1_RX);
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi1TxAltControlTableEntry, (UDMA_CHAN_SSI1_TX | UDMA_ALT_SELECT));
ALLOCATE_CONTROL_TABLE_ENTRY(dmaSpi1RxAltControlTableEntry, (UDMA_CHAN_SSI1_RX | UDMA_ALT_SELECT));


/*
 *  ======== spiCC26X2DMAHWAttrs ========
 */
const SPICC26X2DMA_HWAttrs spiCC26X2DMAHWAttrs[CONFIG_SPI_COUNT] = {
    /* CONFIG_SPI_MEM */
    {
        .baseAddr = SSI0_BASE,
        .intNum = INT_SSI0_COMB,
        .intPriority = (~0),
        .swiPriority = 0,
        .powerMngrId = PowerCC26XX_PERIPH_SSI0,
        .defaultTxBufValue = ~0,
        .rxChannelBitMask = 1<<UDMA_CHAN_SSI0_RX,
        .txChannelBitMask = 1<<UDMA_CHAN_SSI0_TX,
        .dmaTxTableEntryPri = &dmaSpi0TxControlTableEntry,
        .dmaRxTableEntryPri = &dmaSpi0RxControlTableEntry,
        .dmaTxTableEntryAlt = &dmaSpi0TxAltControlTableEntry,
        .dmaRxTableEntryAlt = &dmaSpi0RxAltControlTableEntry,
        .minDmaTransferSize = 10,
        .txPinMux   = IOC_PORT_MCU_SSI0_TX,
        .rxPinMux   = IOC_PORT_MCU_SSI0_RX,
        .clkPinMux  = IOC_PORT_MCU_SSI0_CLK,
        .csnPinMux  = IOC_PORT_MCU_SSI0_FSS,
        .mosiPin = CONFIG_GPIO_SPI_MEM_MOSI,
        .misoPin = CONFIG_GPIO_SPI_MEM_MISO,
        .clkPin  = CONFIG_GPIO_SPI_MEM_SCLK,
        .csnPin  = GPIO_INVALID_INDEX
    },
    /* CONFIG_SPI_IMU */
    {
        .baseAddr = SSI1_BASE,
        .intNum = INT_SSI1_COMB,
        .intPriority = (~0),
        .swiPriority = 0,
        .powerMngrId = PowerCC26XX_PERIPH_SSI1,
        .defaultTxBufValue = ~0,
        .rxChannelBitMask = 1<<UDMA_CHAN_SSI1_RX,
        .txChannelBitMask = 1<<UDMA_CHAN_SSI1_TX,
        .dmaTxTableEntryPri = &dmaSpi1TxControlTableEntry,
        .dmaRxTableEntryPri = &dmaSpi1RxControlTableEntry,
        .dmaTxTableEntryAlt = &dmaSpi1TxAltControlTableEntry,
        .dmaRxTableEntryAlt = &dmaSpi1RxAltControlTableEntry,
        .minDmaTransferSize = 10,
        .txPinMux   = IOC_PORT_MCU_SSI1_TX,
        .rxPinMux   = IOC_PORT_MCU_SSI1_RX,
        .clkPinMux  = IOC_PORT_MCU_SSI1_CLK,
        .csnPinMux  = IOC_PORT_MCU_SSI1_FSS,
        .mosiPin = CONFIG_GPIO_SPI_IMU_MOSI,
        .misoPin = CONFIG_GPIO_SPI_IMU_MISO,
        .clkPin  = CONFIG_GPIO_SPI_IMU_SCLK,
        .csnPin  = CONFIG_GPIO_SPI_IMU_SS
    },
};

/*
 *  ======== SPI_config ========
 */
const SPI_Config SPI_config[CONFIG_SPI_COUNT] = {
    /* CONFIG_SPI_MEM */
    {
        .fxnTablePtr = &SPICC26X2DMA_fxnTable,
        .object = &spiCC26X2DMAObjects[CONFIG_SPI_MEM],
        .hwAttrs = &spiCC26X2DMAHWAttrs[CONFIG_SPI_MEM]
    },
    /* CONFIG_SPI_IMU */
    {
        .fxnTablePtr = &SPICC26X2DMA_fxnTable,
        .object = &spiCC26X2DMAObjects[CONFIG_SPI_IMU],
        .hwAttrs = &spiCC26X2DMAHWAttrs[CONFIG_SPI_IMU]
    },
};

const uint_least8_t CONFIG_SPI_MEM_CONST = CONFIG_SPI_MEM;
const uint_least8_t CONFIG_SPI_IMU_CONST = CONFIG_SPI_IMU;
const uint_least8_t SPI_count = CONFIG_SPI_COUNT;

/*
 *  =============================== UART2 ===============================
 */

#include <ti/drivers/UART2.h>
#include <ti/drivers/uart2/UART2CC26X2.h>
#include <ti/drivers/GPIO.h>
#include <ti/drivers/Power.h>
#include <ti/drivers/dma/UDMACC26XX.h>
#include <ti/drivers/power/PowerCC26X2.h>
#include <ti/devices/cc13x2x7_cc26x2x7/driverlib/ioc.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_memmap.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_ints.h>

#define CONFIG_UART2_COUNT 1

UART2CC26X2_Object uart2CC26X2Objects[CONFIG_UART2_COUNT];

static unsigned char uart2RxRingBuffer0[32];
static unsigned char uart2TxRingBuffer0[32];

ALLOCATE_CONTROL_TABLE_ENTRY(dmaUart1RxControlTableEntry, UDMA_CHAN_UART1_RX);
ALLOCATE_CONTROL_TABLE_ENTRY(dmaUart1TxControlTableEntry, UDMA_CHAN_UART1_TX);

static const UART2CC26X2_HWAttrs uart2CC26X2HWAttrs[CONFIG_UART2_COUNT] = {
  {
    .baseAddr           = UART1_BASE,
    .intNum             = INT_UART1_COMB,
    .intPriority        = (~0),
    .rxPin              = CONFIG_GPIO_UART2_1_RX,
    .txPin              = CONFIG_GPIO_UART2_1_TX,
    .ctsPin             = GPIO_INVALID_INDEX,
    .rtsPin             = GPIO_INVALID_INDEX,
    .flowControl        = UART2_FLOWCTRL_NONE,
    .powerId            = PowerCC26XX_PERIPH_UART1,
    .rxBufPtr           = uart2RxRingBuffer0,
    .rxBufSize          = sizeof(uart2RxRingBuffer0),
    .txBufPtr           = uart2TxRingBuffer0,
    .txBufSize          = sizeof(uart2TxRingBuffer0),
    .txPinMux           = IOC_PORT_MCU_UART1_TX,
    .rxPinMux           = IOC_PORT_MCU_UART1_RX,
    .ctsPinMux          = IOC_PORT_MCU_UART1_CTS,
    .rtsPinMux          = IOC_PORT_MCU_UART1_RTS,
    .dmaTxTableEntryPri = &dmaUart1TxControlTableEntry,
    .dmaRxTableEntryPri = &dmaUart1RxControlTableEntry,
    .rxChannelMask      = 1 << UDMA_CHAN_UART1_RX,
    .txChannelMask      = 1 << UDMA_CHAN_UART1_TX,
    .txIntFifoThr       = UART2CC26X2_FIFO_THRESHOLD_1_8,
    .rxIntFifoThr       = UART2CC26X2_FIFO_THRESHOLD_4_8
  },
};

const UART2_Config UART2_config[CONFIG_UART2_COUNT] = {
    {   /* CONFIG_UART2_1 */
        .object      = &uart2CC26X2Objects[CONFIG_UART2_1],
        .hwAttrs     = &uart2CC26X2HWAttrs[CONFIG_UART2_1]
    },
};

const uint_least8_t CONFIG_UART2_1_CONST = CONFIG_UART2_1;
const uint_least8_t UART2_count = CONFIG_UART2_COUNT;

/*
 *  =============================== Button ===============================
 */
#include <ti/drivers/apps/Button.h>

#define CONFIG_BUTTON_COUNT 1
Button_Object ButtonObjects[CONFIG_BUTTON_COUNT];

static const Button_HWAttrs ButtonHWAttrs[CONFIG_BUTTON_COUNT] = {
    /* CONFIG_BUTTON_0 */
    {
        .gpioIndex = CONFIG_GPIO_BUTTON_IN,
        .pullMode = Button_PULL_UP,
        .internalPullEnabled = 0,
    },
};

const Button_Config Button_config[CONFIG_BUTTON_COUNT] = {
    /* CONFIG_BUTTON_0 */
    {
        .object = &ButtonObjects[CONFIG_BUTTON_0],
        .hwAttrs = &ButtonHWAttrs[CONFIG_BUTTON_0]
    },
};

const uint_least8_t CONFIG_BUTTON_0_CONST = CONFIG_BUTTON_0;
const uint_least8_t Button_count = CONFIG_BUTTON_COUNT;

/*
 *  =============================== LED ===============================
 */
#include <ti/drivers/apps/LED.h>

#define CONFIG_LED_COUNT 4
LED_Object LEDObjects[CONFIG_LED_COUNT];

static const LED_HWAttrs LEDHWAttrs[CONFIG_LED_COUNT] = {
    /* CONFIG_LED_BUTTON */
    {
        .type = LED_GPIO_CONTROLLED,
        .index = CONFIG_LED_BUTTON_GPIO,
    },
    /* CONFIG_LED_RED */
    {
        .type = LED_PWM_CONTROLLED,
        .index = CONFIG_LED_RED_PWM,
    },
    /* CONFIG_LED_GREEN */
    {
        .type = LED_PWM_CONTROLLED,
        .index = CONFIG_LED_GREEN_PWM,
    },
    /* CONFIG_LED_BLUE */
    {
        .type = LED_PWM_CONTROLLED,
        .index = CONFIG_LED_BLUE_PWM,
    },
};

const LED_Config LED_config[CONFIG_LED_COUNT] = {
    /* CONFIG_LED_BUTTON */
    {
        .object = &LEDObjects[CONFIG_LED_BUTTON],
        .hwAttrs = &LEDHWAttrs[CONFIG_LED_BUTTON]
    },
    /* CONFIG_LED_RED */
    {
        .object = &LEDObjects[CONFIG_LED_RED],
        .hwAttrs = &LEDHWAttrs[CONFIG_LED_RED]
    },
    /* CONFIG_LED_GREEN */
    {
        .object = &LEDObjects[CONFIG_LED_GREEN],
        .hwAttrs = &LEDHWAttrs[CONFIG_LED_GREEN]
    },
    /* CONFIG_LED_BLUE */
    {
        .object = &LEDObjects[CONFIG_LED_BLUE],
        .hwAttrs = &LEDHWAttrs[CONFIG_LED_BLUE]
    },
};

const uint_least8_t CONFIG_LED_BUTTON_CONST = CONFIG_LED_BUTTON;
const uint_least8_t CONFIG_LED_RED_CONST = CONFIG_LED_RED;
const uint_least8_t CONFIG_LED_GREEN_CONST = CONFIG_LED_GREEN;
const uint_least8_t CONFIG_LED_BLUE_CONST = CONFIG_LED_BLUE;
const uint_least8_t LED_count = CONFIG_LED_COUNT;

/*
 *  =============================== GPTimer ===============================
 */

#include <ti/drivers/timer/GPTimerCC26XX.h>
#include <ti/drivers/power/PowerCC26XX.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_memmap.h>
#include <ti/devices/cc13x2x7_cc26x2x7/inc/hw_ints.h>

#define CONFIG_GPTIMER_COUNT 3

/*
 *  ======== gptimerCC26XXObjects ========
 */
GPTimerCC26XX_Object gptimerCC26XXObjects[CONFIG_GPTIMER_COUNT];

/*
 *  ======== gptimerCC26XXHWAttrs ========
 */
const GPTimerCC26XX_HWAttrs gptimerCC26XXHWAttrs[CONFIG_GPTIMER_COUNT] = {
    /* CONFIG_GPTIMER_0, used by CONFIG_LED_RED_PWM */
    {
        .baseAddr = GPT2_BASE,
        .intNum      = INT_GPT2A,
        .intPriority = (~0),
        .powerMngrId = PowerCC26XX_PERIPH_GPT2,
        .pinMux      = GPT_PIN_2A
    },
    /* CONFIG_GPTIMER_1, used by CONFIG_LED_GREEN_PWM */
    {
        .baseAddr = GPT0_BASE,
        .intNum      = INT_GPT0A,
        .intPriority = (~0),
        .powerMngrId = PowerCC26XX_PERIPH_GPT0,
        .pinMux      = GPT_PIN_0A
    },
    /* CONFIG_GPTIMER_2, used by CONFIG_LED_BLUE_PWM */
    {
        .baseAddr = GPT1_BASE,
        .intNum      = INT_GPT1A,
        .intPriority = (~0),
        .powerMngrId = PowerCC26XX_PERIPH_GPT1,
        .pinMux      = GPT_PIN_1A
    },
};

/*
 *  ======== GPTimer_config ========
 */
const GPTimerCC26XX_Config GPTimerCC26XX_config[CONFIG_GPTIMER_COUNT] = {
    /* CONFIG_GPTIMER_0 */
    {
        .object    = &gptimerCC26XXObjects[CONFIG_GPTIMER_0],
        .hwAttrs   = &gptimerCC26XXHWAttrs[CONFIG_GPTIMER_0],
        .timerPart = GPT_A
    },
    /* CONFIG_GPTIMER_1 */
    {
        .object    = &gptimerCC26XXObjects[CONFIG_GPTIMER_1],
        .hwAttrs   = &gptimerCC26XXHWAttrs[CONFIG_GPTIMER_1],
        .timerPart = GPT_A
    },
    /* CONFIG_GPTIMER_2 */
    {
        .object    = &gptimerCC26XXObjects[CONFIG_GPTIMER_2],
        .hwAttrs   = &gptimerCC26XXHWAttrs[CONFIG_GPTIMER_2],
        .timerPart = GPT_A
    },
};

const uint_least8_t CONFIG_GPTIMER_0_CONST = CONFIG_GPTIMER_0;
const uint_least8_t CONFIG_GPTIMER_1_CONST = CONFIG_GPTIMER_1;
const uint_least8_t CONFIG_GPTIMER_2_CONST = CONFIG_GPTIMER_2;
const uint_least8_t GPTimer_count = CONFIG_GPTIMER_COUNT;

#include <ti/drivers/Board.h>

/*
 *  ======== Board_initHook ========
 *  Perform any board-specific initialization needed at startup.  This
 *  function is declared weak to allow applications to override it if needed.
 */
void __attribute__((weak)) Board_initHook(void)
{
}

/*
 *  ======== Board_init ========
 *  Perform any initialization needed before using any board APIs
 */
void Board_init(void)
{
    /* ==== /ti/drivers/Power initialization ==== */
    Power_init();

    /* ==== /ti/devices/CCFG initialization ==== */

    /* ==== /ti/drivers/GPIO initialization ==== */
    /* Setup GPIO module and default-initialise pins */
    GPIO_init();

    Board_initHook();
}

