/*
 *  ======== ti_drivers_config.h ========
 *  Configured TI-Drivers module declarations
 *
 *  The macros defines herein are intended for use by applications which
 *  directly include this header. These macros should NOT be hard coded or
 *  copied into library source code.
 *
 *  Symbols declared as const are intended for use with libraries.
 *  Library source code must extern the correct symbol--which is resolved
 *  when the application is linked.
 *
 *  DO NOT EDIT - This file is generated for the CC1312R7RGZ
 *  by the SysConfig tool.
 */
#ifndef ti_drivers_config_h
#define ti_drivers_config_h

#define CONFIG_SYSCONFIG_PREVIEW

#define CONFIG_CC1312R7RGZ
#ifndef DeviceFamily_CC13X2X7
#define DeviceFamily_CC13X2X7
#endif

#include <ti/devices/DeviceFamily.h>

#include <stdint.h>

/* support C++ sources */
#ifdef __cplusplus
extern "C" {
#endif


/*
 *  ======== CCFG ========
 */


/*
 *  ======== ADC ========
 */

/* DIO30 */
extern const uint_least8_t              CONFIG_ADC_VBAT_CONST;
#define CONFIG_ADC_VBAT                 0
#define CONFIG_TI_DRIVERS_ADC_COUNT     1


/*
 *  ======== GPIO ========
 */
/* Owned by CONFIG_UART2_1 as  */
extern const uint_least8_t CONFIG_GPIO_UART2_1_TX_CONST;
#define CONFIG_GPIO_UART2_1_TX 26

/* Owned by CONFIG_UART2_1 as  */
extern const uint_least8_t CONFIG_GPIO_UART2_1_RX_CONST;
#define CONFIG_GPIO_UART2_1_RX 27

/* Owned by CONFIG_ADC_VBAT as  */
extern const uint_least8_t CONFIG_GPIO_ADC_VBAT_AIN_CONST;
#define CONFIG_GPIO_ADC_VBAT_AIN 30

extern const uint_least8_t CONFIG_GPIO_RTCC_INT_CONST;
#define CONFIG_GPIO_RTCC_INT 22

extern const uint_least8_t CONFIG_GPIO_BATT_M_EN_CONST;
#define CONFIG_GPIO_BATT_M_EN 29

extern const uint_least8_t CONFIG_GPIO_CHG_STAT_CONST;
#define CONFIG_GPIO_CHG_STAT 21

extern const uint_least8_t CONFIG_GPIO_IMU_INT_CONST;
#define CONFIG_GPIO_IMU_INT 20

extern const uint_least8_t CONFIG_GPIO_I2C1_EN_CONST;
#define CONFIG_GPIO_I2C1_EN 28

extern const uint_least8_t CONFIG_GPIO_DIO1_CONST;
#define CONFIG_GPIO_DIO1 1

extern const uint_least8_t CONFIG_GPIO_DIO16_CONST;
#define CONFIG_GPIO_DIO16 16

extern const uint_least8_t CONFIG_GPIO_DIO17_CONST;
#define CONFIG_GPIO_DIO17 17

/* Owned by CONFIG_I2C_RTCC as  */
extern const uint_least8_t CONFIG_GPIO_I2C_RTCC_SDA_CONST;
#define CONFIG_GPIO_I2C_RTCC_SDA 5

/* Owned by CONFIG_I2C_RTCC as  */
extern const uint_least8_t CONFIG_GPIO_I2C_RTCC_SCL_CONST;
#define CONFIG_GPIO_I2C_RTCC_SCL 4

/* Owned by CONFIG_SD_0 as  */
extern const uint_least8_t CONFIG_GPIO_MEM_CS_CONST;
#define CONFIG_GPIO_MEM_CS 11

/* Owned by CONFIG_SPI_MEM as  */
extern const uint_least8_t CONFIG_GPIO_SPI_MEM_SCLK_CONST;
#define CONFIG_GPIO_SPI_MEM_SCLK 10

/* Owned by CONFIG_SPI_MEM as  */
extern const uint_least8_t CONFIG_GPIO_SPI_MEM_MISO_CONST;
#define CONFIG_GPIO_SPI_MEM_MISO 9

/* Owned by CONFIG_SPI_MEM as  */
extern const uint_least8_t CONFIG_GPIO_SPI_MEM_MOSI_CONST;
#define CONFIG_GPIO_SPI_MEM_MOSI 8

/* Owned by CONFIG_SPI_IMU as  */
extern const uint_least8_t CONFIG_GPIO_SPI_IMU_SCLK_CONST;
#define CONFIG_GPIO_SPI_IMU_SCLK 15

/* Owned by CONFIG_SPI_IMU as  */
extern const uint_least8_t CONFIG_GPIO_SPI_IMU_MISO_CONST;
#define CONFIG_GPIO_SPI_IMU_MISO 18

/* Owned by CONFIG_SPI_IMU as  */
extern const uint_least8_t CONFIG_GPIO_SPI_IMU_MOSI_CONST;
#define CONFIG_GPIO_SPI_IMU_MOSI 19

/* Owned by CONFIG_BUTTON_0 as  */
extern const uint_least8_t CONFIG_GPIO_BUTTON_IN_CONST;
#define CONFIG_GPIO_BUTTON_IN 12

/* Owned by CONFIG_SPI_IMU as  */
extern const uint_least8_t CONFIG_GPIO_SPI_IMU_SS_CONST;
#define CONFIG_GPIO_SPI_IMU_SS 14

/* Owned by CONFIG_LED_BUTTON as  */
extern const uint_least8_t CONFIG_LED_BUTTON_GPIO_CONST;
#define CONFIG_LED_BUTTON_GPIO 13

/* Owned by CONFIG_GPTIMER_0 as  */
extern const uint_least8_t CONFIG_GPIO_PWM_RED_CONST;
#define CONFIG_GPIO_PWM_RED 25

/* Owned by CONFIG_GPTIMER_1 as  */
extern const uint_least8_t CONFIG_GPIO_PWM_GREEN_CONST;
#define CONFIG_GPIO_PWM_GREEN 6

/* Owned by CONFIG_GPTIMER_2 as  */
extern const uint_least8_t CONFIG_GPIO_PWM_BLUE_CONST;
#define CONFIG_GPIO_PWM_BLUE 7

/* The range of pins available on this device */
extern const uint_least8_t GPIO_pinLowerBound;
extern const uint_least8_t GPIO_pinUpperBound;

/* LEDs are active high */
#define CONFIG_GPIO_LED_ON  (1)
#define CONFIG_GPIO_LED_OFF (0)

#define CONFIG_LED_ON  (CONFIG_GPIO_LED_ON)
#define CONFIG_LED_OFF (CONFIG_GPIO_LED_OFF)


/*
 *  ======== I2C ========
 */

/*
 *  SCL: DIO4
 *  SDA: DIO5
 */
extern const uint_least8_t              CONFIG_I2C_RTCC_CONST;
#define CONFIG_I2C_RTCC                 0
#define CONFIG_TI_DRIVERS_I2C_COUNT     1

/* ======== I2C Addresses and Speeds ======== */
#include <ti/drivers/I2C.h>

/* ---- CONFIG_I2C_RTCC I2C bus components ---- */

/* no components connected to CONFIG_I2C_RTCC */

/* CONFIG_I2C_RTCC.maxBitRate configuration specified 100 Kbps */
#define CONFIG_I2C_RTCC_MAXSPEED   (100U) /* Kbps */
#define CONFIG_I2C_RTCC_MAXBITRATE ((I2C_BitRate)I2C_100kHz)


/*
 *  ======== PWM ========
 */

/* DIO25 */
extern const uint_least8_t              CONFIG_LED_RED_PWM_CONST;
#define CONFIG_LED_RED_PWM              0
/* DIO6 */
extern const uint_least8_t              CONFIG_LED_GREEN_PWM_CONST;
#define CONFIG_LED_GREEN_PWM            1
/* DIO7 */
extern const uint_least8_t              CONFIG_LED_BLUE_PWM_CONST;
#define CONFIG_LED_BLUE_PWM             2
#define CONFIG_TI_DRIVERS_PWM_COUNT     3


/*
 *  ======== SD ========
 */

/*
 *  MOSI: DIO8
 *  MISO: DIO9
 *  SCLK: DIO10
 *  SS: undefined
 */
extern const uint_least8_t              CONFIG_SD_0_CONST;
#define CONFIG_SD_0                     0
#define CONFIG_TI_DRIVERS_SD_COUNT      1


/*
 *  ======== SPI ========
 */

/*
 *  MOSI: DIO8
 *  MISO: DIO9
 *  SCLK: DIO10
 */
extern const uint_least8_t              CONFIG_SPI_MEM_CONST;
#define CONFIG_SPI_MEM                  0
/*
 *  MOSI: DIO19
 *  MISO: DIO18
 *  SCLK: DIO15
 *  SS: DIO14
 */
extern const uint_least8_t              CONFIG_SPI_IMU_CONST;
#define CONFIG_SPI_IMU                  1
#define CONFIG_TI_DRIVERS_SPI_COUNT     2


/*
 *  ======== UART2 ========
 */

/*
 *  TX: DIO26
 *  RX: DIO27
 */
extern const uint_least8_t                  CONFIG_UART2_1_CONST;
#define CONFIG_UART2_1                      0
#define CONFIG_TI_DRIVERS_UART2_COUNT       1


/*
 *  ======== Button ========
 */

extern const uint_least8_t                  CONFIG_BUTTON_0_CONST;
#define CONFIG_BUTTON_0                     0
#define CONFIG_TI_DRIVERS_BUTTON_COUNT      1


/*
 *  ======== LED ========
 */

extern const uint_least8_t              CONFIG_LED_BUTTON_CONST;
#define CONFIG_LED_BUTTON               0
/* DIO25 */
extern const uint_least8_t              CONFIG_LED_RED_CONST;
#define CONFIG_LED_RED                  1
/* DIO6 */
extern const uint_least8_t              CONFIG_LED_GREEN_CONST;
#define CONFIG_LED_GREEN                2
/* DIO7 */
extern const uint_least8_t              CONFIG_LED_BLUE_CONST;
#define CONFIG_LED_BLUE                 3
#define CONFIG_TI_DRIVERS_LED_COUNT     4


/*
 *  ======== GPTimer ========
 */

extern const uint_least8_t                  CONFIG_GPTIMER_0_CONST;
#define CONFIG_GPTIMER_0                    0
extern const uint_least8_t                  CONFIG_GPTIMER_1_CONST;
#define CONFIG_GPTIMER_1                    1
extern const uint_least8_t                  CONFIG_GPTIMER_2_CONST;
#define CONFIG_GPTIMER_2                    2
#define CONFIG_TI_DRIVERS_GPTIMER_COUNT     3


/*
 *  ======== Board_init ========
 *  Perform all required TI-Drivers initialization
 *
 *  This function should be called once at a point before any use of
 *  TI-Drivers.
 */
extern void Board_init(void);

/*
 *  ======== Board_initGeneral ========
 *  (deprecated)
 *
 *  Board_initGeneral() is defined purely for backward compatibility.
 *
 *  All new code should use Board_init() to do any required TI-Drivers
 *  initialization _and_ use <Driver>_init() for only where specific drivers
 *  are explicitly referenced by the application.  <Driver>_init() functions
 *  are idempotent.
 */
#define Board_initGeneral Board_init

#ifdef __cplusplus
}
#endif

#endif /* include guard */
